package br.com.padaria.entity;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;

import org.nextframework.bean.annotation.DescriptionProperty;
import org.nextframework.bean.annotation.DisplayName;
import org.nextframework.validation.annotation.Required;

@Entity
@DisplayName("Funcionrio")
public class Funcionario {

	Long id;
	String nome;
	Arquivo foto;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "sq_Funcionario")
	@SequenceGenerator(name = "sq_Funcionario", sequenceName = "sq_Funcionario")
	public Long getId() {
		return id;
	}
	@DescriptionProperty
	@Required
	public String getNome() {
		return nome;
	}

	@ManyToOne(fetch=FetchType.LAZY)
	public Arquivo getFoto() {
		return foto;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public void setFoto(Arquivo foto) {
		this.foto = foto;
	}

	public void setId(Long id) {
		this.id = id;
	}
}
