package br.com.padaria.entity;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;

import org.nextframework.validation.annotation.Required;

@Entity
public class ItemVenda {
	
	Long id;
	Venda venda;
	Pao pao;
	Integer quantidade;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "sq_ItemVenda")
	@SequenceGenerator(name = "sq_ItemVenda", sequenceName = "sq_ItemVenda")
	public Long getId() {
		return id;
	}
	@ManyToOne(fetch=FetchType.LAZY)
	public Venda getVenda() {
		return venda;
	}
	@ManyToOne(fetch=FetchType.LAZY)
	@Required
	public Pao getPao() {
		return pao;
	}

	@Required
	public Integer getQuantidade() {
		return quantidade;
	}

	public void setVenda(Venda venda) {
		this.venda = venda;
	}

	public void setPao(Pao pao) {
		this.pao = pao;
	}

	public void setQuantidade(Integer quantidade) {
		this.quantidade = quantidade;
	}

	public void setId(Long id) {
		this.id = id;
	}
}
