package br.com.padaria.entity;

import java.util.Date;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;

import org.nextframework.validation.annotation.Required;

@Entity
public class Venda {
	
	Long id;
	Funcionario funcionario;
	Date data = new Date();
	List<ItemVenda> itens;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "sq_Venda")
	@SequenceGenerator(name = "sq_Venda", sequenceName = "sq_Venda")
	public Long getId() {
		return id;
	}
	@ManyToOne(fetch=FetchType.LAZY)
	@Required
	public Funcionario getFuncionario() {
		return funcionario;
	}
	@OneToMany(mappedBy="venda")
	public List<ItemVenda> getItens() {
		return itens;
	}
	public Date getData() {
		return data;
	}
	public void setData(Date data) {
		this.data = data;
	}
	public void setFuncionario(Funcionario funcionario) {
		this.funcionario = funcionario;
	}

	public void setItens(List<ItemVenda> itens) {
		this.itens = itens;
	}

	public void setId(Long id) {
		this.id = id;
	}
}
